//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "QRProject1.h"
#include "qrprintjob.h"
#include "qrprntr.hpp"
#include "quickrpt.hpp"
#include <printers.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PrintBtnClick(TObject *Sender)
{
  PrintBtn->Enabled = false;
  doReport(true);
  PrintBtn->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PreviewBtnClick(TObject *Sender)
{
  PreviewBtn->Enabled = false;
  doReport(false);
  PreviewBtn->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::QuickRep1NeedData(TObject *Sender, bool &MoreData)
{
  MoreData = (++counter == 1);
}
//---------------------------------------------------------------------------
void TForm1::doReport(bool PrintIt)
{
  try
    {
      QuickRep1->Prepare();

      if (PrintIt)
         //QuickRep1->QRPrinter->Print();
         QuickRep1->Print();
      else
        {
         QuickRep1->PrevInitialZoom = qrZoomToFit;
         QuickRep1->PreviewInitialState = wsMaximized;
         QuickRep1->QRPrinter->PreviewModal();
        }
    }
  catch(Exception &e)
    {
      Application->ShowException(&e);
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::QuickRep1BeforePrint(TCustomQuickRep *Sender,
      bool &PrintReport)
{
  counter = 0;
}
//---------------------------------------------------------------------------



void __fastcall TForm1::SpeedButton1Click(TObject *Sender)
{
   TMetafile *page1, *page2;
   TQuickRep *parentReport = new TQuickRep(this);
   parentReport->Page->Orientation = poLandscape;
   parentReport->Page->PaperSize = A4;
   parentReport->PreviewWidth = 900;
   parentReport->PreviewHeight = 700;
   TQRPrinter *nprn = new TQRPrinter(parentReport);
   // prepare reports
   QuickRep1->Prepare();
   // begin QR operations
   nprn->Cleanup();
   nprn->Preview(); // replace with 'Print' do implement printing
   // create the output
   nprn->BeginDoc();
   for(int i=1;i<=1;++i)
   {
      nprn->NewPage();
      page1 = QuickRep1->QRPrinter->PageList->GetPage(i);
      page2 = QuickRep1->QRPrinter->PageList->GetPage(i);
      nprn->Canvas->Draw(0,0, page1);
      nprn->Canvas->Draw(480,0, page2);
   }
   nprn->EndDoc();
   // could remove this loop if printing ( it is always false then)
   while( ! nprn->ShowingPreview)
   {
      Application->ProcessMessages();
   }

}
//---------------------------------------------------------------------------

